/* eslint-disable @typescript-eslint/no-empty-function */
import BaseFoundation from '../base/foundation';
import isPromise from '../utils/isPromise';
export default class PopConfirmFoundation extends BaseFoundation {
  init() {}

  destroy() {}

  handleCancel(e) {
    const maybePromise = this._adapter.notifyCancel(e);

    if (isPromise(maybePromise)) {
      this._adapter.updateCancelLoading(true);

      maybePromise.then(result => {
        this.handleVisibleChange(false);

        this._adapter.updateCancelLoading(false);
      }, errors => {
        this._adapter.updateCancelLoading(false);
      });
    } else {
      this.handleVisibleChange(false);
    }
  }

  handleConfirm(e) {
    const maybePromise = this._adapter.notifyConfirm(e);

    if (isPromise(maybePromise)) {
      this._adapter.updateConfirmLoading(true);

      maybePromise.then(result => {
        this._adapter.updateConfirmLoading(false);

        this.handleVisibleChange(false);
      }, errors => {
        this._adapter.updateConfirmLoading(false);
      });
    } else {
      this.handleVisibleChange(false);
    }
  }

  handleClickOutSide(e) {
    this._adapter.notifyClickOutSide(e);
  }

  handleVisibleChange(visible) {
    if (!this._isControlledComponent('visible')) {
      this._adapter.setVisible(visible);
    }

    this._adapter.notifyVisibleChange(visible);
  }

}